/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* THESE ARE THE INFORMATIONS OF THE MAP: *************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// TOWN OF CHAMPLAIN:
// CREATED BY PAPADAN:
// MARCH 2007:
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** CHOOSE THE NATIVE TRIBES: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
            int subCiv0=-1;
            int subCiv1=-1;
            int subCiv2=-1;
            int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
            int nativeMix=rmRandInt(0,1);
            if (rmAllocateSubCivs(4) == true)
   {
            if (nativeMix <= 0.5)
		{
	        // CREE OUTSIDE, CHEROKEE INSIDE:
			subCiv0=rmGetCivID("Cree");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Cree");

			subCiv3=rmGetCivID("Cree");
			if (subCiv3 >= 0)
			rmSetSubCiv(3, "Cree");

			subCiv1=rmGetCivID("Cherokee");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Cherokee");

			subCiv2=rmGetCivID("Cherokee");
			if (subCiv2 >= 0)
			rmSetSubCiv(2, "Cherokee");
		}
		    else
		{
			// CHEROKEE OUTSIDE, CREE INSIDE:
			subCiv0=rmGetCivID("Cherokee");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Cherokee");

			subCiv3=rmGetCivID("Cherokee");
			if (subCiv3 >= 0)
			rmSetSubCiv(3, "Cherokee");

			subCiv1=rmGetCivID("Cree");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Cree");

			subCiv2=rmGetCivID("Cree");
			if (subCiv2 >= 0)
			rmSetSubCiv(2, "Cree");
		}
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP SIZE: *********************************************** //
/*================================================================================================================*/
	    int playerTiles = 25000;

	    if (cNumberNonGaiaPlayers >4)
		playerTiles = 20000;
	    if (cNumberNonGaiaPlayers >6)
		playerTiles = 15000;

        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	    // SET THE MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
	
	    // SET MAP ELEVATION HEIGHT BLEND:
	    rmSetMapElevationHeightBlend(1);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(1.0);

        // PICKS DEFAULT TERRAIN AND WATER:
	    rmSetSeaType("Amazon River");
/*----------------------------------------------------------------------------------------------------------------*/
	    float terrainPicker = rmRandFloat(0.0, 1.0);
	    if (terrainPicker <= 0.5)
	{
		rmSetBaseTerrainMix("saguenay tundra");
	}
	/*    if (terrainPicker <= 0.6)
	{	
		rmSetBaseTerrainMix("saguenay_forest");
	}	*/
	    else
	{
		rmSetBaseTerrainMix("saguenay grass");
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    // PICKS THE TERRAIN INITIALIZATION:
	    rmTerrainInitialize("saguenay\ground1_sag",10);
	
	    // SET THE MAP TYPE:
		rmSetMapType("saguenay");
	    rmSetMapType("water");
	    rmSetMapType("grass");
	    
	    // SET THE LIGHTING:
	    rmSetLightingSet("saguenay");

	    // CHOOSE THE MERCS:
	    chooseMercs();

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************* DEFINE THE CLASSES: ********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classHill");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("classNugget");
	    rmDefineClass("center");
	    int canyon=rmDefineClass("canyon");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ********************************************* //
/*================================================================================================================*/
	    // MAP EDGE CONSTRAINT:
		
	    // PLAYER CONSTRAINTS:
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 40.0);
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	    int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 20.0);
	    int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 8.0);

	    // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
	
	    // SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        	
	    // CANYONS AVOIDANCE:
	    int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
	    int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	
	    // NATIVES AVOIDANCE:
	    int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 15.0);
		
	    // SYLVER MINES CONSTRAINT:
	    int avoidSilver=rmCreateTypeDistanceConstraint("gold avoid gold", "Mine", 55.0);
	    int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
	
	    // CENTER CONSTRAINT:
	    int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
	    int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
	
	    // FOREST CONSTRAINT:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 50.0);
	    int shortForestConstraint=rmCreateClassDistanceConstraint("short forest vs. forest", rmClassID("classForest"), 10.0);
	    int mediumForestConstraint=rmCreateClassDistanceConstraint("medium forest vs. forest", rmClassID("classForest"), 25.0);
	
	    // IMPORTANT ITEM AVOIDANCE:
	    int shortAvoidImportantItem=rmCreateClassDistanceConstraint("short avoid important", rmClassID("importantItem"), 5.0);

	    // DECORATIONS AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	    // NUGGETS AVOIDANCE:
	    int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 20.0);
	    int shortAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget short", rmClassID("classNugget"), 8.0);
		
	    // RESOURCE AVOIDANCE:
	    int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	
	    // DECORATION CONSTRAINTS:
	   int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	   int avoidVultures=rmCreateTypeDistanceConstraint("avoids Vultures", "PropVulturePerching", 40.0);
	
	    // ANIMALS CONSTRAINTS:
	    int avoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 40.0);
	    int avoidBison=rmCreateTypeDistanceConstraint("avoid Bison", "Bison", 25);
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoid Moose", "moose", 25);
	    int avoidPronghorn=rmCreateTypeDistanceConstraint("avoid Pronghorn", "Pronghorn", 25);
	
	    // TRADE ROUTE CONSTRAINT:
	    int avoidTradeRoute=rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	    int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	
	    // STARTING UNIT AVOIDANCE:
	    int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	
	    // PATCH CONSTRAINT:
	    int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	
	    // CIRCLE CONSTRAINT:
	    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
	// DEFINE TCID:
	int TCID = rmCreateObjectDef("player TC");
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 10.0);
	rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	rmAddObjectDefToClass(TCID, rmClassID("player"));
	rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	// DEFINE STARTING UNITS:
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 8.0);
	rmSetObjectDefMaxDistance(startingUnits, 12.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);

	// DEFINE PLAYER SILVER MINES:
	int playerSilverID = rmCreateObjectDef("player silver");
	rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	rmSetObjectDefMinDistance(playerSilverID, 20.0);
	rmSetObjectDefMaxDistance(playerSilverID, 25.0);
	//rmAddObjectDefConstraint(playerSilverID, avoidAll);
	rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);
	
	int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	//rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnits);
	rmAddObjectDefConstraint(StartBerryBushID, avoidImpassableLand);
	rmAddObjectDefConstraint(StartBerryBushID, shortAvoidSilver);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnits);
	rmAddObjectDefConstraint(StartBerryBushID, avoidResource);
	

	// DEFINE STARTING TREES:
	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", rmRandInt(9,10), 4.0);
	// rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 4.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 9);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	//rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidSilver);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);
 
    // DEFINE STARTING DEERS:
	int startDeersID = rmCreateObjectDef("starting deers");
	rmAddObjectDefItem(startDeersID, "deer", rmRandInt(7,9), 8.0);
	rmSetObjectDefCreateHerd(startDeersID, true);
	rmSetObjectDefMinDistance(startDeersID, 16);
	rmSetObjectDefMaxDistance(startDeersID, 20);
	rmAddObjectDefToClass(startDeersID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startDeersID, avoidImpassableLand);
	rmAddObjectDefConstraint(startDeersID, shortAvoidImportantItem);
	// rmAddObjectDefConstraint(startDeersID, avoidTradeRoute);
	rmAddObjectDefConstraint(startDeersID, avoidStartingUnits);
	rmAddObjectDefConstraint(startDeersID, avoidResource);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** PLACE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
            // --> TCID, startingUnits, playerSilverID, StartAreaTreeID and StartTurkeyID all added to rmClassID("startingUnit")

	        int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);

	        int failCount=0;
	        int numTries=cNumberNonGaiaPlayers*15;
/*================================================================================================================*/
// *************************************** SET UP THE PLAYERS LOCATIONS: **************************************** //
/*================================================================================================================*/
        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.75,0.75);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.250,0.250);	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************************* BUILD AN INVISIBLE "WEST DESERT" AREA: ************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
		int westDesertID = rmCreateArea("west desert");
		rmSetAreaLocation(westDesertID, 0.45, 1.0); 
		rmSetAreaWarnFailure(westDesertID, false);
		rmSetAreaSize(westDesertID, 0.2, 0.2);
		rmSetAreaCoherence(westDesertID, 0.5);
		// rmAddAreaInfluenceSegment(westDesertID, 0.45, 0.1, 0., 0.9);
		//rmSetAreaTerrainType(westDesertID, "texas\ground4_tex");
		//rmAddAreaTerrainLayer(westDesertID, "texas\ground1_tex", 0, 4);
        //rmAddAreaTerrainLayer(westDesertID, "texas\ground2_tex", 4, 10);
        //rmAddAreaTerrainLayer(westDesertID, "texas\ground3_tex", 10, 16);
		rmSetAreaObeyWorldCircleConstraint(westDesertID, false);
		rmSetAreaMix(westDesertID, "saguenay grass");
		rmBuildArea(westDesertID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************* DEFINE THE SET UP PLAYER AREAS ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    float playerFraction=rmAreaTilesToFraction(120);   //KSW ---> Was 100
	    for(i=1; <cNumberPlayers)
	{
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// SET THE CONSTRAINTS:
		//  rmAddAreaConstraint(id, playerConstraint); 
		//  rmAddAreaConstraint(id, playerEdgeConstraint); 
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);

		// SET AREA MIX:
		rmSetAreaMix(id, "saguenay tundra");
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TWO SMALL POND: ************************************ //
/*================================================================================================================*/
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		rmSetAreaWaterType(smallPondID, "saguenay lake");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.35, 0.55); 
		rmBuildArea(smallPondID);
/*----------------------------------------------------------------------------------------------------------------*/
        //int pondClass=rmDefineClass("pond");
        //int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPond2ID=rmCreateArea("small pond 2");
	
		rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		rmSetAreaWaterType(smallPond2ID, "saguenay lake");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.5);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.65, 0.45); 
		rmBuildArea(smallPond2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
//  *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
	    if (subCiv0 == rmGetCivID("cree"))
	{  
		int creeVillageID = -1;
		int creeVillageType = rmRandInt(1,5);
		int randomPlacement = rmRandInt(1,10);
		creeVillageID = rmCreateGrouping("cree village", "native cree village "+creeVillageType);
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		rmSetGroupingMaxDistance(creeVillageID, 20.0);
		rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		rmAddGroupingToClass(creeVillageID, rmClassID("importantItem"));
			if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.45, 0.85);  //KSW ---> Was 0.82, 0.5
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.2);  //KSW ---> Was 0.82, 0.5
			else
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.45, 0.83);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.2);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokeeVillageID = -1;
		int cherokeeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		cherokeeVillageID = rmCreateGrouping("cherokee village", "native cherokee village "+cherokeeVillageType);
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageID, 20.0);
		rmAddGroupingConstraint(cherokeeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("importantItem"));
			if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.45, 0.85);  //KSW ---> Was 0.82, 0.5
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.2);  //KSW ---> Was 0.82, 0.5
			else
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.45, 0.83);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.2);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv1 == rmGetCivID("cherokee"))
	{
		cherokeeVillageID = -1;
		cherokeeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		cherokeeVillageID = rmCreateGrouping("cherokee village", "native cherokee village "+cherokeeVillageType);
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageID, 20.0);
		rmAddGroupingConstraint(cherokeeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.48, 0.6);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.4);
		else
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.48, 0.63);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.4);
		
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv1 == rmGetCivID("cree"))
	{
		creeVillageID = -1;
		creeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		creeVillageID = rmCreateGrouping("cree village", "native cree village "+creeVillageType);
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		rmSetGroupingMaxDistance(creeVillageID, 20.0);
		rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.48, 0.6);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.4);
		else
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.48, 0.63);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.4);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv2 == rmGetCivID("cherokee"))
	{
		cherokeeVillageID = -1;
		cherokeeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		cherokeeVillageID = rmCreateGrouping("cherokee village2", "native cherokee village "+cherokeeVillageType);
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageID, 20.0);
		rmAddGroupingConstraint(cherokeeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.52, 0.4);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.6);
		else
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.2, 0.33);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.6);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv2 == rmGetCivID("cree"))
	{
		creeVillageID = -1;
		creeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		creeVillageID = rmCreateGrouping("cree village2", "native cree village "+creeVillageType);
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		rmSetGroupingMaxDistance(creeVillageID, 20.0);
		rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.52, 0.4);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.6);
		else
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.52, 0.33);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.6);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    if (subCiv3 == rmGetCivID("cherokee"))
	{
		cherokeeVillageID = -1;
		cherokeeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		cherokeeVillageID = rmCreateGrouping("cherokee village2", "native cherokee village "+cherokeeVillageType);
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageID, 20.0);
		rmAddGroupingConstraint(cherokeeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.55, 0.11);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.8);
		else
			//rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.55, 0.17);
			rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.5, 0.8);
		
	}
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv3 == rmGetCivID("cree"))
	{
		creeVillageID = -1;
		creeVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		creeVillageID = rmCreateGrouping("cree village2", "native cree village "+creeVillageType);
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		rmSetGroupingMaxDistance(creeVillageID, 20.0);
		rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 8)
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.55, 0.11);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.8);
		else
			//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.55, 0.17);
			rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.8);
		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
//******************************* DEFINE AND PLACE THE CLIFFS EMBELLISMENTS: ************************************ //
/*================================================================================================================*/	
	    for(i=0; <numTries)
	{
		
		int mesaID=rmCreateArea("mesa 1"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, "New England");
		rmAddAreaToClass(mesaID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesaID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesaID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesaID, avoidCanyons);
		rmSetAreaCoherence(mesaID, 0.5);
		rmSetAreaLocation(mesaID, 0.1, 0.4);
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    for(i=0; <numTries)
	{
		
		int mesa2ID=rmCreateArea("mesa 2"+i);
		rmSetAreaSize(mesa2ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa2ID, false);
		rmSetAreaCliffType(mesa2ID, "New England");
		rmAddAreaToClass(mesa2ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa2ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa2ID, avoidCanyons);
		rmSetAreaCoherence(mesa2ID, 0.5);
		rmSetAreaLocation(mesa2ID, 0.4, 0.1);
		if(rmBuildArea(mesa2ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa3ID=rmCreateArea("mesa 3"+i);
		rmSetAreaSize(mesa3ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa3ID, false);
		rmSetAreaCliffType(mesa3ID, "New England");
		rmAddAreaToClass(mesa3ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa3ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa3ID, avoidCanyons);
		rmSetAreaCoherence(mesa3ID, 0.5);
		rmSetAreaLocation(mesa3ID, 0.6, 0.9);
		if(rmBuildArea(mesa3ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa4ID=rmCreateArea("mesa 4"+i);
		rmSetAreaSize(mesa4ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa4ID, false);
		rmSetAreaCliffType(mesa4ID, "New England");
		rmAddAreaToClass(mesa4ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa4ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa4ID, avoidCanyons);
		rmSetAreaCoherence(mesa4ID, 0.5);
		rmSetAreaLocation(mesa4ID, 0.9, 0.6);
		if(rmBuildArea(mesa4ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa5ID=rmCreateArea("mesa 5"+i);
		rmSetAreaSize(mesa5ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa5ID, false);
		rmSetAreaCliffType(mesa5ID, "New England");
		rmAddAreaToClass(mesa5ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa5ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa5ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa5ID, avoidCanyons);
		rmSetAreaCoherence(mesa5ID, 0.5);
		rmSetAreaLocation(mesa5ID, 0.65, 0.15);
		if(rmBuildArea(mesa5ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa6ID=rmCreateArea("mesa 6"+i);
		rmSetAreaSize(mesa6ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa6ID, false);
		rmSetAreaCliffType(mesa6ID, "New England");
		rmAddAreaToClass(mesa6ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa6ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa6ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa6ID, avoidCanyons);
		rmSetAreaCoherence(mesa6ID, 0.5);
		rmSetAreaLocation(mesa6ID, 0.15, 0.65);
		if(rmBuildArea(mesa6ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa7ID=rmCreateArea("mesa 7"+i);
		rmSetAreaSize(mesa7ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa7ID, false);
		rmSetAreaCliffType(mesa7ID, "New England");
		rmAddAreaToClass(mesa7ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa7ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa7ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa7ID, avoidCanyons);
		rmSetAreaCoherence(mesa7ID, 0.5);
		rmSetAreaLocation(mesa7ID, 0.85, 0.35);
		if(rmBuildArea(mesa7ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}				
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		
		int mesa8ID=rmCreateArea("mesa 8"+i);
		rmSetAreaSize(mesa8ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(mesa8ID, false);
		rmSetAreaCliffType(mesa8ID, "New England");
		rmAddAreaToClass(mesa8ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesa8ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesa8ID, -8, 1.0, 1.0);  
		rmAddAreaConstraint(mesa8ID, avoidCanyons);
		rmSetAreaCoherence(mesa8ID, 0.5);
		rmSetAreaLocation(mesa8ID, 0.35, 0.85);
		if(rmBuildArea(mesa8ID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}					
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ PLACE PLAYERS AND STARTING UNITS **************************************** // 
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		
		// TEST OF MARCIN'S STARTING UNITS STUFF...
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//	rmPlaceObjectDefAtLoc(StartTurkeyID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(startBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startDeersID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		//vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		//rmSetHomeCityGatherPoint(i, closestPoint);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS ****************************************** //
/*================================================================================================================*/
	    for(i=0; <cNumberNonGaiaPlayers*12)
	
	{
		int edgeForestID=rmCreateArea("edgeForest"+i);
		rmSetAreaWarnFailure(edgeForestID, false);
		rmSetAreaSize(edgeForestID, rmAreaTilesToFraction(140), rmAreaTilesToFraction(200));  // was 200 to 250
		rmSetAreaForestType(edgeForestID, "saguenay forest");
		rmSetAreaForestDensity(edgeForestID, 20.0);                         //KSW --> Was 1.0
		rmSetAreaForestClumpiness(edgeForestID, 3.0);		
		rmSetAreaForestUnderbrush(edgeForestID, 0.0);
		rmAddAreaToClass(edgeForestID, rmClassID("classForest"));
		rmSetAreaMinBlobs(edgeForestID, 1);
		rmSetAreaMaxBlobs(edgeForestID, 3);					
		rmSetAreaMinBlobDistance(edgeForestID, 16.0);
		rmSetAreaMaxBlobDistance(edgeForestID, 30.0);
		rmSetAreaCoherence(edgeForestID, 0.4);
		rmSetAreaSmoothDistance(edgeForestID, 8);
		rmAddAreaConstraint(edgeForestID, shortPlayerConstraint);
		rmAddAreaConstraint(edgeForestID, forestConstraint); 
		rmAddAreaConstraint(edgeForestID, shortAvoidSilver);  
		rmAddAreaConstraint(edgeForestID, shortAvoidCanyons); 
		rmAddAreaConstraint(edgeForestID, avoidImpassableLand);
	//	rmAddAreaConstraint(edgeForestID, avoidTradeRouteSockets);
		rmAddAreaConstraint(edgeForestID, avoidStartingUnits);
		rmAddAreaConstraint(edgeForestID, avoidNatives);
		rmAddAreaConstraint(edgeForestID, shortAvoidImportantItem);  // Added New
			if(rmBuildArea(edgeForestID)==false)
			{
				// Stop trying once we fail 10 times in a row.  
				failCount++;
				if(failCount==24)
					break;
			}
			else
				failCount=0; 
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE COIN RESOURCES *************************************** //
/*================================================================================================================*/
	    int silverType = rmRandInt(1,10);   
	    int silverID = -1;
	    int silverCount = cNumberNonGaiaPlayers*4;	//KSW ---> Was number*3
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	
	{
		silverID = rmCreateObjectDef("silver"+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, canyonConstraint);
		rmAddObjectDefConstraint(silverID, avoidSilver);
		rmAddObjectDefConstraint(silverID, mediumPlayerConstraint);
		rmAddObjectDefConstraint(silverID, shortForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, shortAvoidImportantItem);          // Added New
		//rmAddObjectDefConstraint(silverID, avoidTradeRouteSockets);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREES: *************************************** //	
/*================================================================================================================*/	
	    for(i=0; < 25*cNumberNonGaiaPlayers)
	{
		int randomTreeID=rmCreateObjectDef("random tree "+i);
		rmAddObjectDefItem(randomTreeID, "TreeSaguenay", rmRandInt(4,8), 3.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
		rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.3));
		rmAddObjectDefConstraint(randomTreeID, avoidResource);
		//rmAddObjectDefConstraint(randomTreeID, shortAvoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, avoidTradeRouteSockets);
		rmAddObjectDefConstraint(randomTreeID, shortPlayerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidStartingUnits);
		rmAddObjectDefConstraint(randomTreeID, shortAvoidCanyons); 
		rmAddObjectDefConstraint(randomTreeID, shortAvoidImportantItem);				// Added New
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TREASURES: **************************************** //
/*================================================================================================================*/
		// DEFINE AND PLACE THE NUGGETS EASY:
		int nugget1= rmCreateObjectDef("nugget easy"); 
		rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget1, rmClassID("classNugget"));
		rmAddObjectDefConstraint(nugget1, avoidResource);
		rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget1, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
        rmAddObjectDefConstraint(nugget1, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget1, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget1, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget1, avoidNugget);
		rmAddObjectDefConstraint(nugget1, avoidNatives);
		rmAddObjectDefConstraint(nugget1, circleConstraint);
		rmAddObjectDefConstraint(nugget1, shortAvoidImportantItem);			// Added New
		rmSetObjectDefMinDistance(nugget1, 40.0);
		rmSetObjectDefMaxDistance(nugget1, 60.0);
		rmPlaceObjectDefPerPlayer(nugget1, false, 2);

		// DEFINE AND PLACE THE NUGGETS MEDIUM:
		int nugget2= rmCreateObjectDef("nugget medium"); 
		rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
		rmAddObjectDefToClass(nugget2, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget2, 0.0);
		rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nugget2, avoidResource);
		rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget2, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget2, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget2, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget2, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget2, avoidNugget);
		rmAddObjectDefConstraint(nugget2, avoidNatives);
		rmAddObjectDefConstraint(nugget2, circleConstraint);
		rmAddObjectDefConstraint(nugget2, shortAvoidImportantItem);				// Added New
		rmSetObjectDefMinDistance(nugget2, 80.0);
		rmSetObjectDefMaxDistance(nugget2, 120.0);
		rmPlaceObjectDefPerPlayer(nugget2, false, 1);

		// DEFINE AND PLACE THE NUGGETS HARD:
		int nugget3= rmCreateObjectDef("nugget hard"); 
		rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmAddObjectDefToClass(nugget3, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget3, 0.0);
		rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.4));
		rmAddObjectDefConstraint(nugget3, avoidResource);
		rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget3, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget3, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget3, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget3, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget3, avoidNugget);
		rmAddObjectDefConstraint(nugget3, avoidNatives);
		rmAddObjectDefConstraint(nugget3, circleConstraint);
		rmAddObjectDefConstraint(nugget3, shortAvoidImportantItem);					// Added New
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

		// DEFINE AND PLACE THE NUGGETS NUTS:
		int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmAddObjectDefToClass(nugget4, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.4));
		rmAddObjectDefConstraint(nugget4, avoidResource);
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget4, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget4, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget4, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget4, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget4, avoidNugget);
		rmAddObjectDefConstraint(nugget4, avoidNatives);
		rmAddObjectDefConstraint(nugget4, circleConstraint);
		rmAddObjectDefConstraint(nugget4, shortAvoidImportantItem);			// Added New
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(0,3));
/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE NUGGETS EASY IN THE SMALL VALLEYS: ************************** //
/*================================================================================================================*/
		int nuggetID= rmCreateObjectDef("The Valleys Nuggets"); 
		rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmAddObjectDefToClass(nuggetID, rmClassID("classNugget"));
		rmAddObjectDefConstraint(nuggetID, avoidNugget);
		rmSetObjectDefMinDistance(nuggetID, 0.0);
		rmSetObjectDefMaxDistance(nuggetID, 0.0);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.1, 0.4);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.4, 0.1);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.6, 0.9);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.9, 0.6);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.85, 0.35);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.35, 0.85);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE COWS: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	int cowID=rmCreateObjectDef("cow");
	rmAddObjectDefItem(cowID, "cow", 2, 4.0);
	rmSetObjectDefMinDistance(cowID, 0.0);
	rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(cowID, avoidCow);
	// rmAddObjectDefConstraint(cowID, avoidAll);
	rmAddObjectDefConstraint(cowID, playerConstraint);
	rmAddObjectDefConstraint(cowID, shortAvoidCanyons);
	rmAddObjectDefConstraint(cowID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(cowID, shortAvoidNugget);
	rmAddObjectDefConstraint(cowID, shortAvoidImportantItem);					// Added New
	rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE BISON HERDS: **************************************** //
/*================================================================================================================*/
	int MooseID=rmCreateObjectDef("Moose herd");
	rmAddObjectDefItem(MooseID, "moose", rmRandInt(5,7), 6.0);
	rmSetObjectDefCreateHerd(MooseID, true);
	rmSetObjectDefMinDistance(MooseID, 0.0);
	rmSetObjectDefMaxDistance(MooseID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(MooseID, avoidResource);
	// rmAddObjectDefConstraint(MooseID, centerConstraint);
	rmAddObjectDefConstraint(MooseID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(MooseID, avoidMoose);
	rmAddObjectDefConstraint(MooseID, avoidNatives);
	rmAddObjectDefConstraint(MooseID, avoidPronghorn);
	rmAddObjectDefConstraint(MooseID, shortAvoidNugget);
	rmAddObjectDefConstraint(MooseID, playerConstraint);
	rmAddObjectDefConstraint(MooseID, shortAvoidCanyons);
	rmAddObjectDefConstraint(MooseID, shortAvoidImportantItem);					// Added New
	// rmAddObjectDefConstraint(MooseID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(MooseID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE PRONGHORN HERDS: **************************************** //
/*================================================================================================================*/
	int pronghornID=rmCreateObjectDef("pronghorn herd");
	rmAddObjectDefItem(pronghornID, "Pronghorn", rmRandInt(6, 8), 6.0);
	rmSetObjectDefCreateHerd(pronghornID, true);
	rmSetObjectDefMinDistance(pronghornID, 0.0);
	rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(pronghornID, avoidResource);
	// rmAddObjectDefConstraint(pronghornID, centerConstraint);
	rmAddObjectDefConstraint(pronghornID, shortAvoidImpassableLand);		// TEMP fix to allow pronghorn to be placed
	// rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);			// Problem Child
	rmAddObjectDefConstraint(pronghornID, avoidNatives);
	rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	rmAddObjectDefConstraint(pronghornID, shortAvoidNugget);
	rmAddObjectDefConstraint(pronghornID, playerConstraint);
	rmAddObjectDefConstraint(pronghornID, avoidMoose);
	rmAddObjectDefConstraint(pronghornID, avoidStartingUnits);
	//rmAddObjectDefConstraint(pronghornID, shortAvoidCanyons);
	rmAddObjectDefConstraint(pronghornID, shortAvoidImportantItem);					// Added New
	// rmAddObjectDefConstraint(pronghornID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE BUZZARD FLOCK: **************************************** //	
/*================================================================================================================*/
	int buzzardFlockID=rmCreateObjectDef("buzzards");
	rmAddObjectDefItem(buzzardFlockID, "BuzzardFlock", 1, 3.0);
	rmSetObjectDefMinDistance(buzzardFlockID, 0.0);
	rmSetObjectDefMaxDistance(buzzardFlockID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(buzzardFlockID, avoidBuzzards);
	rmAddObjectDefConstraint(buzzardFlockID, avoidTradeRouteSockets);
	rmAddObjectDefConstraint(buzzardFlockID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(buzzardFlockID, playerConstraint);
	rmAddObjectDefConstraint(buzzardFlockID, avoidStartingUnits);
	rmPlaceObjectDefAtLoc(buzzardFlockID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE RANDOM VULTURE TREE: ************************************** //
/*================================================================================================================*/
	int randomVultureTreeID=rmCreateObjectDef("random vulture tree");
	rmAddObjectDefItem(randomVultureTreeID, "PropVulturePerching", 1, 3.0);
	rmAddObjectDefItem(randomVultureTreeID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	rmSetObjectDefMinDistance(randomVultureTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomVultureTreeID, rmXFractionToMeters(0.40));
    rmAddObjectDefConstraint(randomVultureTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomVultureTreeID, playerConstraint);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidStartingUnits);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidBuzzards);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidVultures);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidTradeRoute);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHES: ****************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
	}
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/